// Ex301.ino
//

// モーターの変数 phase/enable mode
const int MOTOR_L_CWCCW = 16; // APH direction
const int MOTOR_R_CWCCW = 17; // BPH direction
const int MOTOR_L_PWM   = 26; // AEN pwm
const int MOTOR_R_PWM   = 4;  // BEN pwm
// PWM
const int CH_0 = 0;
const int CH_1 = 1;
const int LEDC_TIMER_BIT = 10; // PWMの範囲(8bitなら0〜255、10bitなら0〜1023)
const int LEDC_BASE_FREQ = 100000; // 周波数(Hz) 100khz
// スイッチの変数
const int SW_PIN = 25;

void setup(){
  // モータのポート設定
  pinMode(MOTOR_L_CWCCW, OUTPUT);
  pinMode(MOTOR_R_CWCCW, OUTPUT);
  ledcSetup(CH_0, LEDC_BASE_FREQ, LEDC_TIMER_BIT);
  ledcSetup(CH_1, LEDC_BASE_FREQ, LEDC_TIMER_BIT);
  ledcAttachPin(MOTOR_L_PWM, CH_0);
  ledcAttachPin(MOTOR_R_PWM, CH_1);
  ledcWrite(CH_0, 0);
  ledcWrite(CH_1, 0);
  // スイッチピン設定
  pinMode(SW_PIN, INPUT_PULLUP);
}

void loop() {
  while (digitalRead(SW_PIN) == HIGH);// スイッチが押されるまで待機
  delay(1000);
  
  testFwd(1000);
//  testBwd(1000);
//  testRotL(1000);
//  testRotR(1000);
}

// モーターの関数
int left_offset = 0, right_offset = 0;
void motor(int left, int right, int left_c, int right_c) {
  digitalWrite(MOTOR_L_CWCCW,  left_c);
  digitalWrite(MOTOR_R_CWCCW, right_c);
  ledcWrite(CH_0, left  + left_offset);
  ledcWrite(CH_1, right + right_offset);
}

int sp = 300; // モーターのスピード: 0 - 1023

void testFwd(int tau){
  //前進
  left_offset = 0; right_offset = 0;
  motor(sp,sp,HIGH,HIGH);
  delay(tau);
  //停止
  motor(0,0, LOW, LOW);
  delay(500);
}

void testBwd(int tau){
  //後退
  left_offset = 0; right_offset = 0;
  motor(sp,sp,LOW,LOW);
  delay(tau);
  //停止  
  motor(0,0, LOW, LOW);
  delay(500);
}

void testRotL(int tau){
  //前進
  left_offset = 0; right_offset = 0;
  motor(sp,sp,LOW,HIGH);
  delay(tau);
  //停止
  motor(0,0, LOW, LOW);
  delay(500);
}

void testRotR(int tau){
  //前進
  left_offset = 0; right_offset = 0;
  motor(sp,sp,HIGH,LOW);
  delay(tau);
  //停止
  motor(0,0, LOW, LOW);
  delay(500);
}
