//
// myMotor.h
// 2019/10/12 H.K.


// モーターの変数 phase/enable mode
const int MOTOR_L_CWCCW = 16; // APH direction
const int MOTOR_R_CWCCW = 17; // BPH direction
const int MOTOR_L_PWM   = 26; // AEN pwm
const int MOTOR_R_PWM   = 4;  // BEN pwm

// PWM
const int CH_0 = 0;
const int CH_1 = 1;
const int LEDC_TIMER_BIT = 10; // PWMの範囲(8bitなら0〜255、10bitなら0〜1023)
const int LEDC_BASE_FREQ = 100000; // 周波数(Hz) 100khz

void myMotorSetup(void) {
  // モータのポート設定
  pinMode(MOTOR_L_CWCCW, OUTPUT);
  pinMode(MOTOR_R_CWCCW, OUTPUT);
  ledcSetup(CH_0, LEDC_BASE_FREQ, LEDC_TIMER_BIT);
  ledcSetup(CH_1, LEDC_BASE_FREQ, LEDC_TIMER_BIT);
  ledcAttachPin(MOTOR_L_PWM, CH_0);
  ledcAttachPin(MOTOR_R_PWM, CH_1);
  ledcWrite(CH_0, 0);
  ledcWrite(CH_1, 0);
}

// モーターの関数
int left_offset = 0, right_offset = 0;
void motor(int left, int right, int left_c, int right_c) {
  digitalWrite(MOTOR_L_CWCCW,  left_c);
  digitalWrite(MOTOR_R_CWCCW, right_c);
  ledcWrite(CH_0, left  + left_offset);
  ledcWrite(CH_1, right + right_offset);
}

